package main

import (
	"fmt"
	"lcd.it/vertex"
	)


type Abser interface {
	Abs() float64
}


// MyFloat defined here rather than in a separate packe for the sake of simplicity 
type MyFloat float64

func (f MyFloat) Abs() float64 {
	if f < 0 {
		return float64(-f)
	}
	return float64(f)
}


func main() {
	var a, b Abser

	var f MyFloat

	a = vertex.New(3, 4)  // creates a *Vertex which implements Abser
	
	fmt.Println(a.Abs())


	f = -1   // also MyFloat implements Abser	
	b = f  
	
	fmt.Println(b.Abs())

}

