package main

// called as chaining -n numberOfGoroutines -v value

import (
	"flag"
	"fmt"
)


func double(l, r chan int) {
	for {
		r <-  (2 * <-l)
	}
}


func main() {
	// variable (*int) which will be bound to the value specified
	// for a -n flag
	var nGoroutine = flag.Int("n", 5, "number of goroutines")
	var value = flag.Int("v", 1, "input value")
	
	// parse the flags (n in variable nGoroutine)
	flag.Parse()

	// create the leftmost channels
	leftmost := make(chan int)

	var l, r chan int = nil, leftmost

	// iterate over processes: each time  the left channel of the
	// previous process becomes the right channel of the current
	// one, the left is created anew
	for i := 0; i < *nGoroutine; i++ {
		l, r = r, make(chan int)
		go double(l, r)
	}
	
	rightmost := r
	

	leftmost <- *value        // bang!
	
	x := <-rightmost         // wait for completion
	fmt.Println(x)           // result! (2^n)
}
