package main

// called as chaining -n numberOfGoroutines

import (
	"flag"
	"fmt"
)

// variable wich will be bound to the value specified for a -n flag
var nGoroutine = flag.Int("n", 1234, "how many")


func double(l, r chan int) {
	for data := range l {
		r <- 2* data
	}
	close(r)
}



func main() {

	// parse the flags (n in variable nGoroutine)
	flag.Parse()


	// create the leftmost channels
	leftmost := make(chan int)

	var l, r chan int = nil, leftmost
	// iterate over processes: each time  the left channel of the
	// previous porcess becomes the right channel of the current
	// one, the left is created anew
	

	for i := 0; i < *nGoroutine; i++ {
		l, r = r, make(chan int)
		go double(l, r)
	}
	
	rightmost := r
	
	for i:=1; i<5; i++ {
		leftmost <- i      // bang! Start several jobs!!
	}
	close(leftmost)

	for  x := range rightmost {  // wait for completion of all
		fmt.Println(x)       // result! (2^n*i)
	}
}
