package main

import (
	"lcd.it/vertex"
	"lcd.it/vertexC"
	"fmt"
)

type box struct {
	vertex.Vertex
}

type doubleVert struct {
	vertex.Vertex
	vertexC.VertexC
}

type doubleVertOverride struct {
	vertex.Vertex
	vertexC.VertexC
	X int
}

type doubleVertOneBoxed struct {
	box
	vertex.Vertex
}


func main() {

	{
		fmt.Println("Double vertex")
		v := doubleVert{
			*vertex. New(1,2),
			*vertexC.New(3,4,0)}
		fmt.Println(v.VertexC.X)
		//fmt.Println(v.X)        // ambiguous
	}
	
	{
		fmt.Println("Double vertex with overriding (kind of)")
		v := doubleVertOverride{
			*vertex.New(1,2),
			*vertexC.New(3,4,0),
			5}
		fmt.Println(v.Vertex.X)
		fmt.Println(v.X)    // "overridden" value
	}
	
	{
		fmt.Println("Double vertex, the first with boxing")
		v := doubleVertOneBoxed{
			box{*vertex.New(1,2)},
			*vertex.New(3,4)}
		fmt.Println(v.box.Vertex.X)
		fmt.Println(v.X)    // the closest (vertexC) wins
	}
}
