package main

import "fmt"

type MyFun[T any] func (T) T

func execute[T any] (fun MyFun[T] , x T) T {
	return fun(x)
}

func iterate[T any] (fun MyFun[T], n int, x T) T {
	if n == 0 {
		return x
	}
	return fun(iterate(fun, n-1, x))
	
}


func main() {
	fun := func(x int) int {
		return x+1
	}
	
	fmt.Println(execute[int](fun, 2))
	// you can avoid to specify the type parameter when it can be inferred
	fmt.Println(execute(fun, 2))
	fmt.Println(iterate(fun, 10, 2))
}
