/* ufficio 
 Off = (CTM | CS) \ L

 CTM = pay. ('tea.CTM + 'coffee.CTM) 
 
 CS  = publish.'pay.coffee.CS

 oppure

 CS  = publish.'pay.(coffee.CTM + tea.CTM)
*/

package main

import ( 
	"fmt" 
	)


// empty structs used for signalling on channels
type Signal struct{}
var sigVal = struct{}{}

// Coffee & Tea machine
type CTM struct {
	Pay    chan Signal     //  get money
	Coffee chan Signal     //  coffee or tea request
	Tea    chan Signal
}


// CTM behaviour
func (self *CTM) Run () {
	var choice string
	for {
		// get the money
		<- self.Pay   
		fmt.Printf("CTM: Got a coin\n")
		
		// wait for the choice
		select {
		case <- self.Tea: 
			choice = "Tea"
			
		case <- self.Coffee:
			choice = "Coffee"
			
		}
		fmt.Printf("CTM: %s chosen\n", choice)	
	}
}


// CS (publishing channel omitted for the sake of simplicity)
//    (need to know the machine for interacting with it)
func CS (machine *CTM) {
	// kind of beverage chosen
	var beverage string

	for {
		// publish
		fmt.Printf("CS: publish!\n")
		
		// pay
		machine.Pay <- sigVal
		fmt.Printf("CS: pay\n")

		//  choose coffee (or, randomly, tea if not commented)
		select {

		case machine.Coffee <- sigVal:
			fmt.Printf("CS asked for coffee\n")
			beverage = "coffee"
			
		/* comment this for the CS willing only to have coffee */
		case machine.Tea <- sigVal:
			fmt.Printf("CS: asked for tea\n")
			beverage = "tea"
			
		}

		fmt.Printf("CS: got %s\n", beverage)
		
	}
}
	
// main
func main () {
	var machine CTM
	
	machine = CTM{
		make(chan Signal),
		make(chan Signal),
		make(chan Signal)}


	go machine.Run()

	CS(&machine)
		
}
