/* ufficio con piu' computer scientists (indicato come argomento su cmd line)
 Off = (CTM | CS1 | ... | CSn ) \ L
 CTM = pay. ('tea.CTM + 'coffee.CTM) 
 
 CSi  = publish(i).'pay.coffee.CTM

 oppure

 CS  = publish(i).'pay(i).(coffee.CTM + tea.CTM)

 uso: 
 office-multiCS num_of_CS
*/

package main

import ( 
	"fmt"
	"os"
	"strconv"
	)



// Coffee&tea machine
type CTM struct {
	Pay    chan int     //  get money
	Coffee chan int     //  coffee or tea request
	Tea    chan int
}


// CTM behaviour
func (self *CTM) Run () {
	var choice string
	for {
		// get the money
		<- self.Pay   
		fmt.Printf("CTM: Got a coin\n")
		
		// wait for the choice (with timeout)
		select {
		case <- self.Tea: 
			choice = "Tea"
			
		case <- self.Coffee:
			choice = "Coffee"
			
		}
		fmt.Printf("CTM: %s chosen\n", choice)		
	}
}


// CS (publishing channel omitted for the sake of simplicity)

func CS (machine *CTM, id int) {
	// kind of beverage chosen
	var beverage string

	for {
		// publish
		fmt.Printf("CS%d: publish!\n", id)
		
		// pay
		machine.Pay <- 1
		fmt.Printf("CS%d: pay\n", id)

		//  choose coffee (or, randomly, tea if not commented)
		select {

		case machine.Coffee <- 1:
			fmt.Printf("CS%d ask for coffee\n", id)
			beverage = "coffee"
			
		/* comment this for the CS willing only to have coffee */
		case machine.Tea <- 1:
			fmt.Printf("CS%d: ask for tea\n", id)
			beverage = "tea"

		}

		fmt.Printf("CS%d: got %s\n", id, beverage)
		
	}
}
	
// main
func main () {

	if len(os.Args) != 2 { /* a single parameter needed! */
			fmt.Printf("office-multiCS: Usage office-multiCS num_of_CS\n")
		return
	}

	numCS, err := strconv.Atoi(os.Args[1])
	if  err != nil || numCS == 0 {
		fmt.Printf("office-multiCS: Parameter must be an integer > 0\n")
		return
	}


	var machine CTM
	
	machine = CTM{
		make(chan int),
		make(chan int),
		make(chan int)}


	go machine.Run()

	for i:=1; i<numCS; i++ {
		go CS(&machine, i)
		fmt.Printf("CS%d started\n",i)
	}

	CS(&machine, numCS)
	fmt.Printf("CS%d started\n",numCS)
}

