package main

import "fmt"
import "flag"
import "math"
// import "time"
// import "math/rand"


// wait and print what arrives in channel c
func Q (c chan int, quiet bool) {
	for {
		msg := <- c
		if ! quiet {
			fmt.Printf("received %d\n", msg)
		}
	}
}

func main() {
	var iter int    // number of iterations
	var quiet bool  // suppress output of sent/received messages
	flag.IntVar(&iter, "iter", 1000, "number of iterations to perform")
	flag.BoolVar(&quiet, "quiet", false, "suppress output of sent/received messages and print only summary")

	flag.Parse()
	
	c := make(chan int, 100000) 


	// call fun that waits and prints what arrives in channel c
	go Q(c, quiet)

	zeros := 0
	ones  := 0
	
	for i := 0; i < iter; i++ {
		// both are possible ... random choice
		select {
		case c <- 0:
			zeros +=1
			if ! quiet {
				fmt.Println("Sent 0");
			}
			
		case c <- 1:
			ones +=1
			if ! quiet {
				fmt.Println("Sent 1")
			}
			
		default:
			if ! quiet {
				fmt.Println("Never executed? No")
			}
		}
		
	}


	// output number of zeros and ones as a percentage
	fmt.Printf("Zeros: %v %%\n",
		math.Round(100*float64(zeros)/float64(iter)))
	
	fmt.Printf("Ones : %v %%\n",
		math.Round(100*float64(ones)/float64(iter)))
	
}
